

# CreateIpAccessSettings
<a name="API_CreateIpAccessSettings"></a>

Creates an IP access settings resource that can be associated with a web portal.

## Request Syntax
<a name="API_CreateIpAccessSettings_RequestSyntax"></a>

```
POST /ipAccessSettings HTTP/1.1
Content-type: application/json

{
   "additionalEncryptionContext": { 
      "string" : "string" 
   },
   "clientToken": "string",
   "customerManagedKey": "string",
   "description": "string",
   "displayName": "string",
   "ipRules": [ 
      { 
         "description": "string",
         "ipRange": "string"
      }
   ],
   "tags": [ 
      { 
         "Key": "string",
         "Value": "string"
      }
   ]
}
```

## URI Request Parameters
<a name="API_CreateIpAccessSettings_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_CreateIpAccessSettings_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [additionalEncryptionContext](#API_CreateIpAccessSettings_RequestSyntax) **   <a name="workspacesweb-CreateIpAccessSettings-request-additionalEncryptionContext"></a>
Additional encryption context of the IP access settings.  
Type: String to string map  
Key Length Constraints: Minimum length of 0. Maximum length of 131072.  
Key Pattern: `[\s\S]*`   
Value Length Constraints: Minimum length of 0. Maximum length of 131072.  
Value Pattern: `[\s\S]*`   
Required: No

 ** [clientToken](#API_CreateIpAccessSettings_RequestSyntax) **   <a name="workspacesweb-CreateIpAccessSettings-request-clientToken"></a>
A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request.   
If you do not specify a client token, one is automatically generated by the AWS SDK.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 512.  
Required: No

 ** [customerManagedKey](#API_CreateIpAccessSettings_RequestSyntax) **   <a name="workspacesweb-CreateIpAccessSettings-request-customerManagedKey"></a>
The custom managed key of the IP access settings.  
Type: String  
Length Constraints: Minimum length of 20. Maximum length of 2048.  
Pattern: `arn:[\w+=\/,.@-]+:kms:[a-zA-Z0-9\-]*:[a-zA-Z0-9]{1,12}:key\/[a-zA-Z0-9-]+`   
Required: No

 ** [description](#API_CreateIpAccessSettings_RequestSyntax) **   <a name="workspacesweb-CreateIpAccessSettings-request-description"></a>
The description of the IP access settings.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 256.  
Pattern: `.+`   
Required: No

 ** [displayName](#API_CreateIpAccessSettings_RequestSyntax) **   <a name="workspacesweb-CreateIpAccessSettings-request-displayName"></a>
The display name of the IP access settings.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 64.  
Pattern: `.+`   
Required: No

 ** [ipRules](#API_CreateIpAccessSettings_RequestSyntax) **   <a name="workspacesweb-CreateIpAccessSettings-request-ipRules"></a>
The IP rules of the IP access settings.  
Type: Array of [IpRule](API_IpRule.md) objects  
Array Members: Minimum number of 1 item. Maximum number of 100 items.  
Required: Yes

 ** [tags](#API_CreateIpAccessSettings_RequestSyntax) **   <a name="workspacesweb-CreateIpAccessSettings-request-tags"></a>
The tags to add to the IP access settings resource. A tag is a key-value pair.  
Type: Array of [Tag](API_Tag.md) objects  
Array Members: Minimum number of 0 items. Maximum number of 200 items.  
Required: No

## Response Syntax
<a name="API_CreateIpAccessSettings_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "ipAccessSettingsArn": "string"
}
```

## Response Elements
<a name="API_CreateIpAccessSettings_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [ipAccessSettingsArn](#API_CreateIpAccessSettings_ResponseSyntax) **   <a name="workspacesweb-CreateIpAccessSettings-response-ipAccessSettingsArn"></a>
The ARN of the IP access settings resource.  
Type: String  
Length Constraints: Minimum length of 20. Maximum length of 2048.  
Pattern: `arn:[\w+=\/,.@-]+:[a-zA-Z0-9\-]+:[a-zA-Z0-9\-]*:[a-zA-Z0-9]{1,12}:[a-zA-Z]+(\/[a-fA-F0-9\-]{36})+` 

## Errors
<a name="API_CreateIpAccessSettings_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
Access is denied.  
HTTP Status Code: 403

 ** ConflictException **   
There is a conflict.    
 ** resourceId **   
Identifier of the resource affected.  
 ** resourceType **   
Type of the resource affected.
HTTP Status Code: 409

 ** InternalServerException **   
There is an internal server error.    
 ** retryAfterSeconds **   
Advice to clients on when the call can be safely retried.
HTTP Status Code: 500

 ** ServiceQuotaExceededException **   
The service quota has been exceeded.    
 ** quotaCode **   
The originating quota.  
 ** resourceId **   
Identifier of the resource affected.  
 ** resourceType **   
 Type of the resource affected.  
 ** serviceCode **   
The originating service.
HTTP Status Code: 402

 ** ThrottlingException **   
There is a throttling error.    
 ** quotaCode **   
The originating quota.  
 ** retryAfterSeconds **   
Advice to clients on when the call can be safely retried.  
 ** serviceCode **   
The originating service.
HTTP Status Code: 429

 ** ValidationException **   
There is a validation error.    
 ** fieldList **   
The field that caused the error.  
 ** reason **   
Reason the request failed validation
HTTP Status Code: 400

## See Also
<a name="API_CreateIpAccessSettings_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/workspaces-web-2020-07-08/CreateIpAccessSettings) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/workspaces-web-2020-07-08/CreateIpAccessSettings) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/workspaces-web-2020-07-08/CreateIpAccessSettings) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/workspaces-web-2020-07-08/CreateIpAccessSettings) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/workspaces-web-2020-07-08/CreateIpAccessSettings) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/workspaces-web-2020-07-08/CreateIpAccessSettings) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/workspaces-web-2020-07-08/CreateIpAccessSettings) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/workspaces-web-2020-07-08/CreateIpAccessSettings) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/workspaces-web-2020-07-08/CreateIpAccessSettings) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/workspaces-web-2020-07-08/CreateIpAccessSettings) 